#include "hdf.h"

/*
$Header: rline.c,v 1.2 91/04/09 16:29:56 mullm_update Exp $

$Log:	rline.c,v $
 * Revision 1.2  91/04/09  16:29:56  mullm_update
 * Added RCS keywords
 * 
*/


/*
 *   Bresenham's vector -> raster line conversion alogrithm,
 *   written in special brute-force-and-ignorance style.
 */

void rline( x1, y1, x2, y2 )
int x1,y1,x2,y2;
{
        int dx,dy,step1,step2,d,deltap,deltaq,i;
        void SetPixel();

	x1 = MAPX(x1); x2 = MAPX(x2);
	y1 = MAPY(y1); y2 = MAPY(y2);

        dx= abs( x2-x1 );
        dy= abs( y2-y1 );
        step1 = ( (x1<x2) ? 1 : (-1) );
        step2 = ( (y1<y2) ? 1 : (-1) );

        SetPixel( x1, y1 );

        if( dy <= dx )
        {
                deltap = dy+dy;
                     d = deltap-dx;
                deltaq = d-dx;

                while ( x1 != x2 )
                {
                        x1 += step1;

                        if ( d < 0 )
                                d += deltap;
                        else
                        {
                                y1 += step2;
                                d  += deltaq;
                        }

                        SetPixel( x1, y1 );
                }
        }
        else
        {
                deltap = dx+dx;
                     d = deltap - dy;
                deltaq = d - dy;

                while( y1 != y2 )
                {
                        y1 +=  step2;

                        if ( d < 0 )
                                d += deltap;
                        else
                        {
                                x1 += step1;
                                d += deltaq;
                        }

                        SetPixel( x1, y1 );
                }
        }
}
        

